/*
  ==============================================================================

    WaveformThumbnail.h
    Created: 1 Aug 2021 5:37:04pm
    Author:  nweihsma

  ==============================================================================
*/

#pragma once

#include <JuceHeader.h>
//i need access to audioProcessor
#include "PluginProcessor.h"


//==============================================================================
/*
*/
class WaveformThumbnailComponent : public juce::Component,
    public juce::FileDragAndDropTarget
{
public:

    WaveformThumbnailComponent(FinalSamplerAudioProcessor&);
    ~WaveformThumbnailComponent() override;

    void paint(juce::Graphics&) override;
    void resized() override;

private:

    //pure virtuals for FileDragAndDrop

    bool isInterestedInFileDrag(const juce::StringArray& fileArray) override;
    void filesDropped(const juce::StringArray& fileArray, int x, int y) override;


    //string to hold file name gotten from unique file pointer
    juce::String myFileName = "";

    //vector of points taken at interval to draw
    std::vector<float> pointsToDrawWaveform;

    //boolean so it knows when to draw
    bool shouldPaintWaveform = false;

    //declare reference sampler audio processor object so i can access methods and data
    FinalSamplerAudioProcessor& myAudioProcessor;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(WaveformThumbnailComponent)
};
