#pragma once

#include <JuceHeader.h>

//==============================================================================
/*
*/
class AdsrComponent : public juce::Component
{
public:
    AdsrComponent(juce::AudioProcessorValueTreeState& myTreeState);
    ~AdsrComponent() override;

    void paint(juce::Graphics&) override;
    void resized() override;

private:
    //declare sliders, labels, and sliderAttachments 
    juce::Slider attackSlider;
    juce::Slider decaySlider;
    juce::Slider sustainSlider;
    juce::Slider releaseSlider;

    juce::Label attackLabel {"Attack Time", "Attack Time"};
    juce::Label decayLabel { "Decay Time", "Decay Time" };
    juce::Label sustainLabel { "Sustain", "Sustain" };
    juce::Label releaseLabel{ "Release Time", "Release Time" };

    std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment> attackSliderAttachment;
    std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment> decaySliderAttachment;
    std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment> sustainSliderAttachment;
    std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment> releaseSliderAttachment;


    //helper method
    void sliderAndLabelSetup(juce::AudioProcessorValueTreeState& treeState,
        std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment>& sliderAttachment,
        juce::Slider& slider, juce::Label& label, const juce::String parameterID);


    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(AdsrComponent)
};
