
#pragma once

#include <JuceHeader.h>



//==============================================================================
/*
*/
class FilterComponent : public juce::Component
{
public:
    FilterComponent(juce::String componentName, juce::AudioProcessorValueTreeState& treeState, juce::String selectorID, juce::String filterResonanceParameterID,
        juce::String filterCutoffParameterID);
    ~FilterComponent() override;

    void paint(juce::Graphics&) override;
    void resized() override;

private:
    //combobox for filter types
    juce::ComboBox filterTypeSelector;
    std::unique_ptr<juce::AudioProcessorValueTreeState::ComboBoxAttachment> filterTypeSelectorAttachment;
    juce::Label filterSelectorLabel {"Filter Type", "Filter Type: "};

    //delcare sliders, labels, and attachments for tunable parameters
    juce::Slider filterResonanceSlider;
    juce::Slider filterCutoffFrequencySlider;

    juce::Label filterResonanceSliderLabel{ "Filter Resonance", "Filter Resonance"};
    juce::Label filterCutoffSliderLabel {"Filter Cutoff", "Filter Cutoff"};

    std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment> filterResonanceSliderAttachment;
    std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment> filterCutoffSliderAttachment;

    //helper method to setup and connect sliders, labels, and attachments
    void sliderAndLabelSetup(juce::AudioProcessorValueTreeState& treeState,
        std::unique_ptr<juce::AudioProcessorValueTreeState::SliderAttachment>& sliderAttachment,
        juce::Slider& slider, juce::Label& label, const juce::String parameterID);

    //to keep track of the 2 filters
    juce::String myComponentName;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(FilterComponent)
};
