
#pragma once
#include <JuceHeader.h>

//don't need to inherit anything. This is a wrapper for juce StateVariableTPTFilter
class FilterData
{
public:

    //dsp process needs preparetoplay() where you pass buffersize and samplerate to 
    void prepareToPlay(int numberOfChannels, double sampleRate, int samplesPerBlock);

    void process(juce::AudioBuffer<float>& buffer);
        //docs say const juce::ProcessContext& context, but can use buffer for simplicity

    void reset();
    void updateFilterParameters(const int filterType, const float filterResonance, const float filterCutoffFrequency);


private:
    //declare state variable filter to process float buffers
    juce::dsp::StateVariableTPTFilter<float> myStateVariableFilter;
    //this juce tpt class is designed for fast modulation, uses tpt structure designed by audio engineer Vadim Zavalishin 
    // Infinite response filter that can do 3 types of filtering, based on
    //the analog state variable filter circuit
    
    bool hasBeenPrepared = false;
    //to ensure prepareToPlay gets called

};
