
#pragma once

#include <JuceHeader.h>

class OscillatorData : public juce::dsp::Oscillator<float>
{
public:

    void setOscillatorWaveType(const int waveChoice);

    void setFMOscillatorWaveType(const int waveChoice);

    void prepareToPlay(juce::dsp::ProcessSpec& mySpec);

    void getNextAudioBlock(juce::dsp::AudioBlock<float>& myBlock);

    void setWaveFrequency(const int midiNoteNumber);

    // method to deal with FM params
    void setFrequencyModulationParameters(const float modulationFrequency, const float modulationDepth);

private:
    //floats for fm oscillator params
    float myModulationDepth = 0.0f;
    float frequencyModulation = 0.0f;

    //to pass not number to setFmParamas
    int currentMidiNoteNumber;

    //new oscilator to control main one via FM 
    juce::dsp::Oscillator<float> frequencyModulationOscillator{};


};
